#!/usr/bin/perl
use Socket;
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}

# Authorizing and processing
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
&errauth if ($encline ne "$alogin:$apassword");
$destination=$data{method};
&$destination;

sub genset
{
$methods=qq~<option value=genset selected>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
&closedb;
open (F,"<$adcpath/template/agenset.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub general
{
open (F, ">adc.cfg");
print F qq~#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$adcpath="$data{adcpath}";
\$backuppath="$data{backuppath}";
\$cgi="$data{cgi}";
\$adcenter="$data{adcenter}";
\$sysid="$data{sysid}";
\$furl="$data{furl}";
\$yourname="$data{yourname}";
\$creditsystem=$data{creditsystem};
\$zoneflag=$data{zoneflag};
\$target="$data{target}";
\$delay=$data{delay};
\$mysqlhost="$data{mysqlhost}";
\$mysqldb="$data{mysqldb}";
\$mysqllogin="$data{mysqllogin}";
\$mysqlpassword="$data{mysqlpassword}";
\$alogin='$alogin';
\$apassword='$apassword';
\$locktables=$data{locktables};
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
\%calendar=('Jan','31','Feb','28','Mar','31','Apr','30','May','31','Jun','30','Jul','31','Aug','31','Sep','30','Oct','31','Nov','30','Dec','31');
\@cal=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
\$license="$license";
~;
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
&genset;
}

sub genstat
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat selected>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,username,password FROM adc_users ORDER BY username");
while(($uid,$username,$password)=$sth->fetchrow)
{
	@imp=();
	@clc=();
	$sthx=$dbh->query("LOCK TABLES adc_imp READ, adc_clc READ") if ($locktables);
	$sthx=$dbh->query("SELECT SUM(adc_imp.h00),SUM(adc_imp.h01),SUM(adc_imp.h02),SUM(adc_imp.h03),SUM(adc_imp.h04),SUM(adc_imp.h05),SUM(adc_imp.h06),SUM(adc_imp.h07),SUM(adc_imp.h08),SUM(adc_imp.h09),SUM(adc_imp.h10),SUM(adc_imp.h11),SUM(adc_imp.h12),SUM(adc_imp.h13),SUM(adc_imp.h14),SUM(adc_imp.h15),SUM(adc_imp.h16),SUM(adc_imp.h17),SUM(adc_imp.h18),SUM(adc_imp.h19),SUM(adc_imp.h20),SUM(adc_imp.h21),SUM(adc_imp.h22),SUM(adc_imp.h23) FROM adc_imp WHERE uid=$uid");
	@imp=$sthx->fetchrow;
	$sthx=$dbh->query("SELECT SUM(adc_clc.h00),SUM(adc_clc.h01),SUM(adc_clc.h02),SUM(adc_clc.h03),SUM(adc_clc.h04),SUM(adc_clc.h05),SUM(adc_clc.h06),SUM(adc_clc.h07),SUM(adc_clc.h08),SUM(adc_clc.h09),SUM(adc_clc.h10),SUM(adc_clc.h11),SUM(adc_clc.h12),SUM(adc_clc.h13),SUM(adc_clc.h14),SUM(adc_clc.h15),SUM(adc_clc.h16),SUM(adc_clc.h17),SUM(adc_clc.h18),SUM(adc_clc.h19),SUM(adc_clc.h20),SUM(adc_clc.h21),SUM(adc_clc.h22),SUM(adc_clc.h23) FROM adc_clc WHERE uid=$uid");
	@clc=$sthx->fetchrow;
	$sthx=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sthx="";
	$timp=0;
	$tclc=0;
	foreach(@imp){$timp+=$_;}
	foreach(@clc){$tclc+=$_;}
	$result.=qq~<tr><td width="60%" valign="top"><font size=2><b><a href="$cgi/adcstat.pl?name=$username&password=$password&method=genstats" target"_blank">$username</a></b></font></td><td width="20%" align="right"><font size=2>$timp</font></td><td width="20%" align="right"><font size=2>$tclc</font></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($result)
{
	$result=qq~<tr><td width="60%" valign="top"><font size=2><b>Username</b></font></td><td width="20%" align="right"><font size=2><b>Impressions</b></font></td><td width="20%" align="right"><font size=2><b>Clicks</b></font></td></tr>\n$result~;
}
else
{
	$result=qq~<tr><td width="60%" valign="top"><font size=2><b>Username</b></font></td><td width="20%" align="right"><font size=2><b>Impressions</b></font></td><td width="20%" align="right"><font size=2><b>Clicks</b></font></td></tr>\n<tr><td align=center><font size=2>No one user in DB</font></td></tr>~;
}
&closedb;
open (F,"<$adcpath/template/agenstat.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub usrman
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$zoneboxes="";
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,username FROM adc_users ORDER BY username");
while(($uid,$username)=$sth->fetchrow)
{
	push(@users,"<option value=\"$uid\">$username</option>\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
$sth=$dbh->query("SELECT zid,zonename FROM adc_zones ORDER BY zonename");
while(($zid,$zonename)=$sth->fetchrow)
{
	$zoneboxes.="<font size=2>$zonename</font><input type=checkbox name=page value=\"$zid\"><br>\n";
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$zoneboxes="<font color=red><b>CREATE ZONE FIRST</b></font>" unless ($zoneboxes);
if ($zoneflag){$zonehere=qq~<tr><td width="26%"><font size="2">&nbsp;Advertising zone</font></td><td width="74%" align="right">$zoneboxes</td></tr>~;}
else{$zonehere=qq~<tr><td width="26%"><font size="2">&nbsp;Advertising page</font></td><td width="74%" align="right"><input type="text" name="page" size="41"></td></tr>~;}
&closedb;
open (F,"<$adcpath/template/ausrman.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub chpass
{
$data{name}=$data{admname};
$data{password}=$data{admpassword};
$alogin=crypt($data{name},$data{name});
$apassword=crypt($data{password},$data{password});
open (F, ">adc.cfg");
print F qq~#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$adcpath="$adcpath";
\$basepath="$basepath";
\$cgi="$cgi";
\$adcenter="$adcenter";
\$sysid="$sysid";
\$furl="$furl";
\$yourname="$yourname";
\$creditsystem=$creditsystem;
\$zoneflag=$zoneflag;
\$target="$target";
\$delay=$delay;
\$mysqlhost="$mysqlhost";
\$mysqldb="$mysqldb";
\$mysqllogin="$mysqllogin";
\$mysqlpassword="$mysqlpassword";
\$alogin='$alogin';
\$apassword='$apassword';
\$locktables=$locktables;
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
\%calendar=('Jan','31','Feb','28','Mar','31','Apr','30','May','31','Jun','30','Jul','31','Aug','31','Sep','30','Oct','31','Nov','30','Dec','31');
\@cal=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
\$license="$license";
~;
&usrman;
}

sub modify
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$zoneboxes="";
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT username,stime,etime,ratio,expdate,target FROM adc_users WHERE uid=$data{username}");
($username,$stime,$etime,$ratio,$expdate,$page)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
while(length($stime)<6){$stime="0$stime";}
while(length($etime)<6){$etime="0$etime";}
$stimeh=substr($stime,0,2);
$stimem=substr($stime,2,2);
$etimeh=substr($etime,0,2);
$etimem=substr($etime,2,2);
($expyear,$expmonth,$expdate)=split("-",$expdate);
if ($zoneflag)
{
	$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
	$sth=$dbh->query("SELECT zid,zonename FROM adc_zones ORDER BY zonename");
	while(($zid,$zonename)=$sth->fetchrow)
	{
		if ($page=~/\,$zid\,/){$checked="checked";}
		else {$checked="";}
		$zoneboxes.="<font size=2>$zonename</font><input type=checkbox name=page value=\"$zid\" $checked><br>\n";
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$zonehere=qq~<tr><td width="26%"><font size="2">&nbsp;Advertising zone</font></td><td width="74%" align="right">$zoneboxes</td></tr>~;
}
else{$page=~s/^,//;$page=~s/,$//;$zonehere=qq~<tr><td width="26%"><font size="2">&nbsp;Advertising page</font></td><td width="74%" align="right"><input type="text" name="page" size="41" value="$page"></td></tr>~;}
&closedb;
open (F,"<$adcpath/template/amodacc.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub modify_f
{
unless ($data{stime}=~/\d{2}:\d{2}/ || $data{etime}=~/\d{2}:\d{2}/)
{
	push(@errors,"<li>Wrong <b>Advertizing period</b> value</li>");
	$flag=1;
}
if (!$data{ratio} || $data{ratio}=~/\D+/ || $data{ratio}>100)
{
	push(@errors,"<li>Wrong <b>Banner ratio</b> value</li>");
	$flag=1;
}
&error if ($flag);
$data{stime}=~s/://;
$data{etime}=~s/://;
$data{stime}.="00";
$data{etime}.="00";
if ($data{exdate} && $data{exmonth} && $data{exyear})
{
	$data{exdate}="0".$data{exdate} if (length $data{exdate}==1);
	$data{exmonth}="0".$data{exmonth} if (length $data{exmonth}==1);
	$expdates="$data{exyear}-$data{exmonth}-$data{exdate}";
}
else
{
	$expdates="";
}
$data{page}=",$data{page},";
$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE adc_users SET stime=$data{stime},etime=$data{etime},ratio=$data{ratio},expdate='$expdates',target='$data{page}' WHERE uid=$data{username}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&modify;
}

sub add
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM adc_users WHERE username='$data{username}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$uid=$sth->fetchrow;
if ($uid)
{
	push(@errors,"<li>User <b>$data{username}</b> is already exist in the database</li>");
	$flag=1;
}
if (!$data{username} || $data{username}=~/\W+/)
{
	push(@errors,"<li>Wrong or missing <b>username</b></li>");
	$flag=1;
}
if (!$data{pass} || $data{pass}=~/\W+/)
{
	push(@errors,"<li>Wrong or missing <b>password</b></li>");
	$flag=1;
}
unless ($data{stime}=~/\d{2}:\d{2}/ && $data{etime}=~/\d{2}:\d{2}/)
{
	push(@errors,"<li>Wrong <b>Advertizing period</b> value</li>");
	$flag=1;
}
if (!$data{ratio} || $data{ratio}=~/\D+/ || $data{ratio}>100)
{
	push(@errors,"<li>Wrong <b>Banner ratio</b> value</li>");
	$flag=1;
}
&error if ($flag);
$data{stime}=~s/://;
$data{etime}=~s/://;
$data{stime}.="00";
$data{etime}.="00";
if ($data{exdate} && $data{exmonth} && $data{exyear})
{
	$data{exdate}="0".$data{exdate} if (length $data{exdate}==1);
	$data{exmonth}="0".$data{exmonth} if (length $data{exmonth}==1);
	$expdates="$data{exyear}-$data{exmonth}-$data{exdate}";
}
else {$expdates="";}
$data{page}=",$data{page},";
$username=$data{username};
$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO adc_users (username,password,stime,etime,ratio,icred,ccred,expdate,target) VALUES ('$data{username}','$data{pass}',$data{stime},$data{etime},$data{ratio},0,0,'$expdates','$data{page}')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$data{username}=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$adcpath/template/aaddacc.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub add_banner
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
unless ($data{url}=~/^http:\/\// || $data{html})
{
	push(@errors,"<li>You must set URL starting with <b>http://</b> or enter banner code</li>");
	$flag=1;
}
&error if ($flag);
$data{html}=~s/\r\n/ /g;
$data{alt}=~s/'/\\'/g;
$data{url}=~s/'/\\'/g;
$data{banner}=~s/'/\\'/g;
$data{html}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES adc_banners WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO adc_banners (uid,url,alt,urltb,bcode) VALUES ($data{username},'$data{url}','$data{alt}','$data{banner}','$data{html}')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$current=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&usrman if ($data{banner} || $data{html});
&closedb;
open (F,"<$adcpath/template/auplban.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub add_banner1
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman selected>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT username FROM adc_users WHERE uid=$data{username}");
$username=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$adcpath/template/abanadd.tpl");
@htmlpage=<F>;
close (F);
&closedb;
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub add_banner2
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman selected>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
unless ($data{url}=~/^http:\/\// || $data{html})
{
	push(@errors,"<li>You must set URL starting with <b>http://</b> or enter banner code</li>");
	$flag=1;
}
&error if ($flag);
$data{html}=~s/\r\n/ /g;
$sth=$dbh->query("LOCK TABLES adc_banners WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO adc_banners (uid,url,alt,urltb,bcode) VALUES ($data{username},'$data{url}','$data{alt}','$data{banner}','$data{html}')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$current=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&banman if ($data{banner} || $data{html});
&closedb;
open (F,"<$adcpath/template/auplban1.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remove
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT username FROM adc_users WHERE uid=$data{username}");
$username=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$adcpath/template/aremcon.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub remove2
{
$sth=$dbh->query("LOCK TABLES adc_users WRITE, adc_banners WRITE, adc_clc WRITE, adc_imp WRITE") if ($locktables);
$sth=$dbh->query("SELECT bid FROM adc_banners WHERE uid=$data{username}");
while($bid=$sth->fetchrow)
{
	unlink ("$adcpath/banners/$bid.gif");
	unlink ("$adcpath/banners/$bid.jpg");
}
$sth=$dbh->query("DELETE FROM adc_imp WHERE uid=$data{username}");
$sth=$dbh->query("DELETE FROM adc_clc WHERE uid=$data{username}");
$sth=$dbh->query("DELETE FROM adc_banners WHERE uid=$data{username}");
$sth=$dbh->query("DELETE FROM adc_users WHERE uid=$data{username}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&usrman;
}

sub add_credits
{
$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE adc_users SET icred=icred+$data{imp},ccred=ccred+$data{clc} WHERE uid=$data{username}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&usrman;
}

sub banman
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman selected>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,username FROM adc_users ORDER BY username");
while(($uid,$username)=$sth->fetchrow)
{
	push(@users,"<option value=\"$uid\">$username</option>\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$adcpath/template/abanman.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub banners
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman selected>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,url,alt,urltb,bcode FROM adc_banners WHERE uid=$data{username}");
while(($ban,$url,$alt,$banner,$bvc)=$sth->fetchrow)
{
	if ($bvc)
	{
		$banner="";
		$bv="<center>$bvc</center>";
	}
	elsif ($banner)
	{
		$bvc="";
		$bv="<center><img src=\"$banner\"></center>";
	}
	else
	{
		if (-e "$adcpath/banners/$ban.gif")
		{
			$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
			$banner="UPLOADED";
			$bvc="";
		}
		else
		{
			$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
			$banner="UPLOADED";
			$bvc="";
		}
	}
	$res.=qq~<tr><td width="450"><form method="POST" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type=hidden name=username value="$data{username}"><input type=hidden name=banno value="$ban">
$bv
<table border="0" width="100%" bgcolor="#00B0B0" cellspacing="0" cellpadding="0">
<tr><td width="40%"><font size="2">&nbsp;URL to website</font></td>
<td width="60%" align="right"><input type="text" name="url" size="41" value="$url"></td></tr>
<tr><td width="40%"><font size="2">&nbsp;ALT text for banner</font></td>
<td width="60%" align="right"><input type="text" name="alt" size="41" value="$alt"></td></tr>
<tr><td width="40%"><font size="2">&nbsp;URL to image banner</font></td>
<td width="60%" align="right"><input type="text" name="banner" size="41" value="$banner"></td></tr>
<tr><td width="40%"><font size="2">&nbsp;Banner code (paste<br>&nbsp;here 3rd-party banner<br>&nbsp;exchange code, or<br>&nbsp;Flash or Java banner<br>&nbsp;code)</font></td><td width="70%" align="right"><textarea name="html" rows=6 cols=30>$bvc</textarea></td></tr>~;
$res.=qq~<tr><td colspan=2><font size=2>Flash/Java banner redirection link:<br>$cgi/adcredir.pl?$data{username}&$ban</font></td></tr>~ if ($bvc);
$res.=qq~<tr><td colspan=2 align="right"><input type="submit" value="remove_banner" name="method"><input type="submit" value="modify_banner" name="method"></td></tr></table></form></td></tr>~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($res)
{
	$res="<tr><td colspan=5><font size=2>Empty database. No one banner for this user.</font></td></tr>";
}
&closedb;
open (F,"<$adcpath/template/ablist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub modify_banner
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman selected>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
unless ($data{url}=~/^http:\/\// || $data{html})
{
	push(@errors,"<li>You must set URL starting with <b>http://</b> or enter banner code</li>");
	$flag=1;
}
&error if ($flag);
$bantoset=$data{banner};
$bantoset="" unless ($data{banner}=~/^http\:\/\//);
$data{html}=~s/\r\n/ /g;
$sth=$dbh->query("LOCK TABLES adc_banners WRITE") if ($locktables);
$sth=$dbh->query("UPDATE adc_banners SET url='$data{url}',alt='$data{alt}',urltb='$bantoset',bcode='$data{html}' WHERE (uid=$data{username} AND bid=$data{banno})");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&banners if ($data{banner}=~/^http\:\/\// || $data{banner} eq "UPLOADED" || $data{html});
$current=$data{banno};
&closedb;
open (F,"<$adcpath/template/auplban.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub remove_banner
{
$sth=$dbh->query("LOCK TABLES adc_banners WRITE, adc_imp WRITE, adc_clc WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM adc_imp WHERE (uid=$data{username} AND bid=$data{banno})");
$sth=$dbh->query("DELETE FROM adc_clc WHERE (uid=$data{username} AND bid=$data{banno})");
$sth=$dbh->query("DELETE FROM adc_banners WHERE (uid=$data{username} AND bid=$data{banno})");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unlink ("$adcpath/banners/$data{banno}.gif");
unlink ("$adcpath/banners/$data{banno}.jpg");
&banners;
}

sub user
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user selected>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT username,stime,etime,ratio,icred,ccred,expdate,target FROM adc_users ORDER BY username");
while(($username,$stime,$etime,$ratio,$imp,$clc,$expdate)=$sth->fetchrow)
{
	while(length($stime)<6){$stime="0$stime";}
	while(length($etime)<6){$etime="0$etime";}
	$stime=substr($stime,0,2).":".substr($stime,2,2);
	$etime=substr($etime,0,2).":".substr($etime,2,2);
	if ($expdate ne "0000-00-00")
	{
		$expdate=substr($expdate,8,2)."/".substr($expdate,5,2)."/".substr($expdate,0,4);
	}
	else {$expdate="Non-expirable";}
	push (@found,"<tr><td><font size=2><b>User:</b> $username</font></td></tr><tr><td><font size=2><b>Advertising time:</b>$stime-$etime</font></td></tr><tr><td><font size=2><b>Banner ratio:</b> $ratio%</font></td></tr><tr><td><font size=2><b>Expiration date:</b> $expdate</font></td></tr><tr><td><font size=2><b>Impressions credits:</b> $imp</font></td></tr><tr><td><font size=2><b>Clicks credits:</b> $clc</font></td></tr><tr><td align=\"center\"><img src=\"$adcenter/images/wl.gif\"></td></tr>\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless (@found) {push (@found,"<tr><td colspan=5><font size=2>Empty database. No one user.</font></td></tr>");}
&closedb;
open (F,"<$adcpath/template/alist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub zone
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone selected>Zone management</option>\n~ if ($zoneflag);
$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
$sth=$dbh->query("SELECT zid,zonename FROM adc_zones ORDER BY zonename");
while(($zid,$zonename)=$sth->fetchrow)
{
	$zones.="<option value=\"$zid\">$zonename</option>\n";
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$adcpath/template/azone.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub add_zone
{
if (!$data{zone} || $data{zone}=~/\W+/)
{
	push(@errors,"<li>Wrong or missing <b>zone name</b></li>");
	$flag=1;
}
&error if ($flag);
$sth=$dbh->query("LOCK TABLES adc_zones WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO adc_zones (zonename) VALUES ('$data{zone}')");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&zone;
}

sub remove_zone
{
$sth=$dbh->query("LOCK TABLES adc_zones WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM adc_zones WHERE zid=$data{zone}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&zone;
}

sub html
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html selected>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
srand;
$rdig=rand;
if ($zoneflag)
{
	$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
	$sth=$dbh->query("SELECT zid,zonename FROM adc_zones ORDER BY zonename");
	while(($zid,$zonename)=$sth->fetchrow)
	{
		$data{zone}=$zid if ($data{zone} eq "");
		$zonaname=$zonename if ($data{zone}==$zid);
		$zones.="<option value=\"$zid\">$zonename</option>\n";
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&closedb;
	open (F,"<$adcpath/template/ahtmlz.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
else
{
	&closedb;
	open (F,"<$adcpath/template/ahtml.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
}

sub error
{
&closedb;
open (F,"<$adcpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}

sub errauth
{
&closedb;
open (F,"<$adcpath/template/errauth.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub systools
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools selected>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
$status.="Backup system status:<br>";
($atime,$mtime)=(stat("$_$file"))[8,9];
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if (@files)
{
	($atime,$mtime)=(stat("$backuppath/$files[0]"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
	$status.="Database was backed up on $date/$month/$year $time";
}
else
{
	$status.="Database wasnt backed up.";
}
&closedb;
open (F,"<$adcpath/template/asystools.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
$sth=$dbh->query("LOCK TABLES adc_users WRITE, adc_banners WRITE, adc_imp WRITE, adc_clc WRITE, adc_zones WRITE, adc_ilock WRITE, adc_clock WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE adc_users,adc_banners,adc_imp,adc_clc,adc_zones,adc_ilock,adc_clock TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&systools;
}
sub delete_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files)
{
	unlink("$backuppath/$_");
}
&systools;
}
sub install_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if(@files)
{
	$sth=$dbh->query("LOCK TABLES adc_users WRITE, adc_banners WRITE, adc_imp WRITE, adc_clc WRITE, adc_zones WRITE, adc_ilock WRITE, adc_clock WRITE") if ($locktables);
	$sth=$dbh->query("DROP TABLE adc_users,adc_banners,adc_imp,adc_clc,adc_zones,adc_ilock,adc_clock");
	$sth=$dbh->query("RESTORE TABLE adc_users,adc_banners,adc_imp,adc_clc,adc_zones,adc_ilock,adc_clock FROM '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub sql_dump
{
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_users");
while (($uid,$username,$password,$stime,$etime,$ratio,$ccred,$icred,$expdate,$target)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_users (uid,username,password,stime,etime,ratio,ccred,icred,expdate,target) VALUES ($uid,'$username','$password',$stime,$etime,$ratio,$ccred,$icred,'$expdate','$target');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_zones");
while (($zid,$zonename)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_zones (zid,zonename) VALUES ($zid,'$zonename');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_banners");
while (($bid,$uid,$url,$alt,$urltb,$bcode)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_banners (bid,uid,url,alt,urltb,bcode) VALUES ($bid,$uid,'$url','$alt','$urltb','$bcode');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_imp");
while (($sid,$uid,$bid,$statd,$h00,$h01,$h02,$h03,$h04,$h05,$h06,$h07,$h08,$h09,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_imp (sid,uid,bid,statd,h00,h01,h02,h03,h04,h05,h06,h07,h08,h09,h10,h11,h12,h13,h14,h15,h16,h17,h18,h19,h20,h21,h22,h23) VALUES ($sid,$uid,$bid,'$statd',$h00,$h01,$h02,$h03,$h04,$h05,$h06,$h07,$h08,$h09,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_clc");
while (($sid,$uid,$bid,$statd,$h00,$h01,$h02,$h03,$h04,$h05,$h06,$h07,$h08,$h09,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_clc (sid,uid,bid,statd,h00,h01,h02,h03,h04,h05,h06,h07,h08,h09,h10,h11,h12,h13,h14,h15,h16,h17,h18,h19,h20,h21,h22,h23) VALUES ($sid,$uid,$bid,'$statd',$h00,$h01,$h02,$h03,$h04,$h05,$h06,$h07,$h08,$h09,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_ilock READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_ilock");
while (($iid,$ip,$ldate)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_ilock (iid,ip,ldate) VALUES (iid,'ip','ldate');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_clock READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM adc_clock");
while (($iid,$ip,$ldate)=$sth->fetchrow)
{
	$file.="INSERT INTO adc_clock (cid,ip,ldate) VALUES (cid,'ip','ldate');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"adc_tables.sql\"; \n";
print "content-type: application/sqldump\n\n";
print $file;
exit;
}
sub reset_db
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools selected>System tools</option>
~;
&closedb;
open (F,"<$adcpath/template/ardb.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_db1
{
if ($data{type} eq "all")
{
	$sth=$dbh->query("LOCK TABLES adc_users WRITE, adc_banners WRITE, adc_imp WRITE, adc_clc WRITE, adc_zones WRITE, adc_ilock WRITE, adc_clock WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM adc_users");
	$sth=$dbh->query("DELETE FROM adc_banners");
	$sth=$dbh->query("DELETE FROM adc_zones");
	$sth=$dbh->query("DELETE FROM adc_imp");
	$sth=$dbh->query("DELETE FROM adc_clc");
	$sth=$dbh->query("DELETE FROM adc_ilock");
	$sth=$dbh->query("DELETE FROM adc_clock");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "lockip")
{
	$sth=$dbh->query("LOCK TABLES adc_ilock WRITE, adc_clock WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM adc_ilock");
	$sth=$dbh->query("DELETE FROM adc_clock");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub reset_stats
{
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools selected>System tools</option>
~;
&closedb;
open (F,"<$adcpath/template/arstats.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_stats1
{
$sth=$dbh->query("LOCK TABLES adc_imp WRITE, adc_clc WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM adc_imp WHERE statd<'$data{year}-$data{month}-$data{date}'");
$sth=$dbh->query("DELETE FROM adc_clc WHERE statd<'$data{year}-$data{month}-$data{date}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&systools;
}

sub closedb
{
$sth="";
$dbh="";
}

&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $adcenter/index.html\n\n";
exit;

